SystemOrganization addCategory: #ConfigurationOfSpec!

Object subclass: #ConfigurationOfSpec
	instanceVariableNames: 'project'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ConfigurationOfSpec'!

!ConfigurationOfSpec commentStamp: '<historical>' prior: 0!
A ConfigurationOfSpec is a class to properly load Specs!

!ConfigurationOfSpec class methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/23/2012 17:42'!
bootstrapPackage: aString from: aPath 
	| repository version |
	repository := MCHttpRepository
				location: aPath
				user: ''
				password: ''.
	repository
		versionReaderForFileNamed: aString , '.mcz'
		do: [:reader | 
			version := reader version.
			version load.
			version workingCopy repositoryGroup addRepository: repository]! !

!ConfigurationOfSpec class methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/23/2012 17:42'!
ensureMetacello
	"Bootstrap Gofer (if necessary), bootstrap ConfigurationOfMetacello (using old Gofer API), then load the latest 
	version of Metacello itself."

	Smalltalk at: #MetacelloProject ifAbsent: [
		Smalltalk at: #Gofer ifAbsent: [
			"Current version of Gofer from which to bootstrap - as of 1.0-beta.15"
			self bootstrapPackage: 'Gofer-lr.83' from: 'http://seaside.gemstone.com/ss/metacello' ].
		Smalltalk at: #Gofer ifPresent: [:goferClass | | gofer |
			gofer := goferClass new
				url: 'http://seaside.gemstone.com/ss/metacello';
				yourself.
			[ gofer addPackage: 'ConfigurationOfMetacello' ] on: Warning do: [:ex | ex resume ].
			gofer load ].
		"load latest version of Metacello, load a specific version if desired"
		(Smalltalk at: #ConfigurationOfMetacello) perform: #loadLatestVersion ]! !

!ConfigurationOfSpec class methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/23/2012 17:42'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfSpec class methodsFor: 'loading' stamp: 'BenjaminVanRyseghem 2/23/2012 18:54'!
loadBasic

	(self project version: #stable) load: 'basic'! !

!ConfigurationOfSpec class methodsFor: 'loading' stamp: 'BenjaminVanRyseghem 2/23/2012 18:54'!
loadCore

	(self project version: #stable) load: 'core'! !

!ConfigurationOfSpec class methodsFor: 'loading' stamp: 'BenjaminVanRyseghem 2/23/2012 18:48'!
loadDefault

	(self project version: #stable) load: 'default'! !

!ConfigurationOfSpec class methodsFor: 'loading' stamp: 'BenjaminVanRyseghem 2/23/2012 18:54'!
loadFull

	(self project version: #stable) load: 'full'! !

!ConfigurationOfSpec class methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/23/2012 17:42'!
project

	^self new project! !

!ConfigurationOfSpec methodsFor: 'baselines' stamp: 'BenjaminVanRyseghem 2/23/2012 18:32'!
baseline10: spec 
	<version: '1.0-baseline'>
	

	spec for: #pharo do: [
		
		"Info"
		spec blessing: #baseline.
		spec repository: 'http://ss3.gemstone.com/ss/Spec'.
		
		"Our own stuff"
		spec 
			package: 'Spec-Core';
			package: 'Spec-Examples' with: [ spec requires: #('Spec-Core' 'Spec-Widgets') ];
			package: 'Spec-Tests' with: [ spec requires: #('Spec-Core') ];
			package: 'Spec-Tools'  with: [ spec requires: #('Spec-Core' 'Spec-Widgets') ];
			package: 'Spec-Widgets'.
			
		spec 
			group: 'basic' with: #('core' 'Spec-Widgets');
			group: 'core' with: #('Spec-Core' 'Spec-Tests');
			group: 'full' with: #('default' 'Spec-Example');
			group: 'default' with: #('basic' 'Spec-Tools') ]! !

!ConfigurationOfSpec methodsFor: 'symbolics' stamp: 'BenjaminVanRyseghem 2/23/2012 18:35'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '0.1'.
! !

!ConfigurationOfSpec methodsFor: 'project' stamp: 'BenjaminVanRyseghem 2/23/2012 18:39'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		self class ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear.
		project ]! !

!ConfigurationOfSpec methodsFor: 'symbolics' stamp: 'BenjaminVanRyseghem 2/23/2012 18:35'!
stable: spec
	<symbolicVersion: #stable>

	spec for: #'common' version: '0.1'.! !

!ConfigurationOfSpec methodsFor: 'versions' stamp: 'BenjaminVanRyseghem 2/23/2012 19:36'!
version01: spec
	<version: '0.1' imports: #('1.0-baseline' )>

	spec for: #'pharo' do: [
		
		spec 
			blessing: #'development';
			description: '01 : First C0nfiguration';
			author: 'BenjaminVanRyseghem';
			timestamp: '2/23/2012 18:33'.
		
		spec 
			package: 'Spec-Examples' with: 'Spec-Examples-BenjaminVanRyseghem.1';
			package: 'Spec-Core' with: 'Spec-Core-BenjaminVanRyseghem.2';
			package: 'Spec-Tests' with: 'Spec-Tests-BenjaminVanRyseghem.1';
			package: 'Spec-Tools' with: 'Spec-Tools-BenjaminVanRyseghem.3';
			package: 'Spec-Widgets' with: 'Spec-Widgets-BenjaminVanRyseghem.1']! !
